#!/bin/sh
#synolra=../linux-dsx14j-3.2.40-22259
synolra=.
synofab=88f628x
synolvb=mainline

for b in `cat branch-list.txt` ; do
  synofam=comcerto2k
  synolxa=3.2.40
  synolva=${b}

  if [ ${synolva} -lt 3200 ]; then
    synolxa=3.2.11
  elif [ ${synolva} -lt 3700 ]; then
    synolxa=3.2.30
  fi
  if [ ${synofab} = 88f628x ]; then
    synolxa=2.6.32
  fi

  if [ ${synolva} -lt 3203 ]; then
    synofam=x64
  elif [ ${synolva} -lt 4450 ]; then
    synofam=armada370
  fi

  echo ""
  v=${synolxa}
  u=https://seafile.servator.de/nas/synology/unmodified/${synofab}/${b}/linux-${v}.tar.xz
  d=linux-${v}-${b}-unpatched
  #e=${d}
  #if [ ${b} -gt 24922 ]; then
  #  e=linux-${v}-${b}-patched0
  #fi
  e=linux-${v}-${synolvb}-unpatched
  if [ ! -e ${synolra}/${e} ]; then
    if [ ${synolvb} = 3203 ]; then
      synolvb=3201
      e=linux-${v}-${synolvb}-unpatched
    fi
    if [ ${synolvb} = 5644 ]; then
      synolvb=5565
      e=linux-${v}-${synolvb}-unpatched
    fi
  fi

  echo $u
  if [ ! -e linux-${v}-${b}.tar.xz ]; then
    if wget -N $u ; then
      mv linux-${v}.tar.xz linux-${v}-${b}.tar.xz
    fi
  fi
  if [ -e linux-${v}-${b}.tar.xz -a ! -e linux-${v}-${b}-unpatched ]; then
    tar xJf linux-${v}-${b}.tar.xz
    mv linux-${v} linux-${v}-${b}-unpatched

    cd $d
    if [ -L arch/arm/plat-armada ]; then
      rm arch/arm/plat-armada
    fi
    if [ -e arch/arm/plat-armada -a ! -e arch/arm/plat-armada-v2 ]; then
      mv arch/arm/plat-armada arch/arm/plat-armada-v2
    fi
    cd ..
  fi

  #p=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}.patch
  #q=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}-extra.patch
  p=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}.patch
  w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB.patch
  q=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-extra.patch
  z=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-extra-bin

  if [ ! -e ${synolra}/${e} ]; then
    echo "Skipping ${p}"
    if [ ${synolva} != 3203 -a ${synolva} != 5644 ]; then
      synolvb=${synolva}
    fi
    continue
  fi

  changerevs=false
  if [ ${synolvb} = mainline -o ${synolvb} = 1373 ]; then
    changerevs=true
  fi
  restoredefs=false
  if [ ${synolva} = 5004 -o ${synolva} = 25426 ]; then
    restoredefs=true
  fi
  removedefs=false
  if [ ${synolva} = 5510 -o ${synolva} = 8451 ]; then
    removedefs=true
  fi

  if [ -L ${synolra}/${e}/arch/microblaze/boot/dts/system.dts -a \
     ! -e ${d}/arch/microblaze/boot/dts/system.dts ]; then
    rm ${synolra}/${e}/arch/microblaze/boot/dts/system.dts
  fi

  if [ -e linux-${v}-${b}-unpatched -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    #echo "${synolra}/${e} to ${d}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  if [ -e linux-${v}-${b}-unpatched -a ${synofam} != ${synofab} -a ! -e ${w} ]; then
    if [ $removedefs = true ]; then
    echo "Creating ${w}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -wbBur a b > ${w} || true
    rm a
    rm b
    fi
  fi

  c=linux-${v}-${synolvb}-patched0
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-remove-defines.patch
  if [ -e ${w} ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/

      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _defabc-${synolvb}-files.txt
      echo "Modifying defines..."
      sh mod-defs.sh ${c} _defabc-${synolvb}
      sh add-abc-defs.sh ${c} ${w}
    fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${synolra}/${e} a
      ln -s ${c} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    synolra=.
    e=${c}
  fi

  c=linux-${v}-${synolvb}-patched0r
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-remove-comments.patch
  if [ -e ${w} -a ${synolva} = 8451 ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/

      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _comment-files.txt
      echo "Removing comments..."
      sh remove-comments.sh ${c} -i
    fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${synolra}/${e} a
      ln -s ${c} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    synolra=.
    e=${c}
  fi

  w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2.patch
  if [ -e linux-${v}-${b}-unpatched -a ${synofam} != ${synofab} -a ! -e ${w} ]; then
    if [ $restoredefs = true -o $removedefs = true ]; then
    echo "Creating ${w}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -wbBur a b > ${w} || true
    rm a
    rm b
    fi
  fi

  if [ -e ${p} ]; then
    rm -f ${z}-files.txt
    rm -f ${z}-files-add.txt
    rm -f ${z}-files-del.txt
    grep '^Nur in ' ${p} | grep -v gitignore | sed "s|: |/|g" | cut -d / -f 2- | sed s/'\.$'/''/g | grep -E '\.pdf$' | while read f ; do
      echo "Binary $f"
      echo ${f}>>${z}-files.txt
      if [ -e ${d}/$f ]; then
        echo ${f}>>${z}-files-add.txt
      else
        echo ${f}>>${z}-files-del.txt
      fi
    done
    if [ -e ${z}-files-add.txt ]; then
      #rm -f ${q}
      cd ${d}
      tar --files-from=../${z}-files-add.txt -czvf ../${z}.tar.gz
      cd ..
    fi
  fi

  if [ -e ${p} -a ! -e ${q} ]; then
    #if grep -q '^Nur in b/' ${p} ; then
    if grep -q '^Nur in ' ${p} ; then
      echo "Creating ${q}"
      #echo "${synolra}/${e} to ${d}"
      ln -s ${synolra}/${e} a
      ln -s ${d} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      #grep '^Nur in b/' ${p} | grep -v gitignore | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
      grep '^Nur in ' ${p} | grep -v gitignore | sed "s|: |/|g" | cut -d / -f 2- | sed s/'\.$'/''/g | while read f ; do
        if echo $f | grep -q -E '\.pdf$' ; then
          continue
        fi
        if [ -d b/$f -o -d b/$f ]; then
          #echo "diff -urN a/$f b/$f"
          diff -urN a/$f b/$f >> ${q} || true
        else
          #echo "diff -uN a/$f b/$f"
          diff -uN a/$f b/$f >> ${q} || true
        fi
      done
      rm a
      rm b
    fi
  fi

  c=linux-${v}-${synolva}-patched0n
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-restore-defines.patch
  if [ -e ${w} -a $restoredefs = true ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${d}/. ${c}/

      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _defabc-${synolvb}-files.txt
      echo "Modifying defines..."
      sh mod-defs.sh ${c} _defabc-${synolvb}
      sh add-abc-defs.sh ${c} ${w} -r
    fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${c} a
      ln -s ${d} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    synolra=.
    d=${c}
  fi

  if [ $changerevs = true ]; then
    w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v0.patch
    
    #echo "Cleanup..."
    #rm -rf linux-${synolxa}-${synolvb}-patched0q/
    #rm -rf linux-${synolxa}-${synolva}-patched0r/

    grep -E '^\+\+\+' ${p} | cut -f 1 | cut -d / -f 2- > _comment-files.txt

    if [ ! -e linux-${synolxa}-${synolvb}-patched0q ]; then
      echo "Creating linux-${synolxa}-${synolvb}-patched0q..."
      mkdir linux-${synolxa}-${synolvb}-patched0q
      cp -apP  linux-${synolxa}-${synolvb}-unpatched/. linux-${synolxa}-${synolvb}-patched0q/

      echo "Removing comments..."
      sh remove-comments.sh linux-${synolxa}-${synolvb}-patched0q -i -m
    fi
    
    if [ ! -e linux-${synolxa}-${synolva}-patched0r ]; then
      echo "Creating linux-${synolxa}-${synolva}-patched0r..."
      mkdir linux-${synolxa}-${synolva}-patched0r
      cp -apP  linux-${synolxa}-${synolva}-unpatched/. linux-${synolxa}-${synolva}-patched0r/

      echo "Removing comments..."
      sh remove-comments.sh linux-${synolxa}-${synolva}-patched0r -i -m
    fi
    
    l="arch/cris/arch-v10/README.mm
    Documentation/video4linux/README.pvrusb2"
    for f in ${l} ; do 
      if [ -e linux-${synolxa}-${synolvb}-patched0q/${f} -a \
           -e linux-${synolxa}-${synolva}-patched0r/${f} ]; then
        cp -p linux-${synolxa}-${synolvb}-patched0q/${f} linux-${synolxa}-${synolva}-patched0r/${f}
      fi
    done
    
    if [ ! -e ${w} ]; then
      echo "Creating ${w}..."
      diff -wbBur linux-${synolxa}-${synolvb}-patched0q linux-${synolxa}-${synolva}-patched0r > ${w} || true
      #grep -E '1\.1\.1\.1' ${w}
    fi
 
    if false ; then
    c=linux-${synolxa}-${synolvb}-patched0m
    r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-change-revisions.patch
    if [ -e ${w} ]; then
      echo "Creating ${c}"
      if [ ! -e ${c} ]; then
        mkdir ${c}
        cp -apP ${synolra}/${e}/. ${c}/
  
        echo "Copying changed files..."
        grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- | while read f ; do
          cp -p ${d}/$f ${c}/$f
        done
      fi
  
      if [ -e ${c} -a ! -e ${r} ]; then
        echo "Creating ${r}"
        #ln -s ${synolra}/${e} a
        #ln -s ${c} b
        ln -s ${c} a
        ln -s ${d} b
        rm -f a/include/linux/version.h
        rm -f b/include/linux/version.h
        diff -ur a b > ${r} || true
        rm a
        rm b
      fi
  
      #synolra=.
      #e=${c}
      #d=${c}
    fi
    fi
  fi

  c=linux-${v}-${b}-patched1
  if [ -e ${w} ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/
    fi
    echo "Copying changed files..."
    grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- | while read f ; do
      #echo $f
      cp -p ${d}/$f ${c}/$f
    done
    #grep '^Nur in ' ${w} | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
    #  echo "rm $f"
    #done
  fi

  o=${p}
  p=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v2.patch
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    ln -s ${synolra}/${e} a
    ln -s ${c} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-whitespace.patch
  if [ $changerevs = true ]; then
    s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-change-revisions.patch
  fi
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${s} ]; then
    echo "Creating ${s}"
    ln -s ${c} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${s} || true
    rm a
    rm b
  fi

  synolvb=${synolva}
done

echo OK
