#!/bin/sh
#synolra=../linux-dsx14j-3.2.40-22259
synolra=.
synofab=armada38x
#synofab=x64
synolxb=3.10.35
synolvb=mainline

for b in `cat branch-list.txt` ; do
  synofam=comcerto2k
  synolxa=3.2.40
  synolva=${b}

  synofab=armada38x
  if [ ${synolva} -lt 5644 ]; then
    synofab=x64
  fi

  if [ ${synolva} -gt 15152 ]; then
    synolxa=3.10.105
  elif [ ${synolva} -gt 8451 ]; then
    synolxa=3.10.102
  elif [ ${synolva} -gt 5644 ]; then
    synolxa=3.10.77
  elif [ ${synolva} -gt 5004 ]; then
    synolxa=3.10.35
  fi

  if [ ${synolva} -lt 2636 ]; then
    synolxa=2.6.32
  elif [ ${synolva} -lt 3200 ]; then
    synolxa=3.2.11
  elif [ ${synolva} -lt 3700 ]; then
    synolxa=3.2.30
  fi

  if [ ${synofab} = 88f628x ]; then
    synolxa=2.6.32
  fi

  if [ ${synolva} -lt 3203 ]; then
    synofam=x64
  elif [ ${synolva} -lt 4450 ]; then
    synofam=armada370
  fi

  if [ ${synolxa:0:5} != "3.10." ]; then
    echo "Skipping ${synofab}/${synolva}/linux-${synolxa}"
    continue
  fi

  echo ""
  v=${synolxa}
  u=https://seafile.servator.de/nas/synology/unmodified/${synofab}/${synolva}/linux-${synolxa}.tar.xz
  d=linux-${synolxa}-${synolva}-unpatched
  #e=${d}
  #if [ ${synolva} -gt 24922 ]; then
  #  e=linux-${synolxa}-${synolva}-patched0
  #fi
  e=linux-${synolxb}-${synolvb}-unpatched
  if [ ! -e ${synolra}/${e} ]; then
    if [ ${synolvb} = 3203 ]; then
      synolvb=3201
      e=linux-${synolxb}-${synolvb}-unpatched
    fi
    if [ ${synolvb} = 5644 ]; then
      synolvb=5565
      e=linux-${synolxb}-${synolvb}-unpatched
    fi
  fi

  echo $u
  if [ ! -e linux-${synolxa}-${synolva}.tar.xz ]; then
    if wget -N $u ; then
      mv linux-${synolxa}.tar.xz linux-${synolxa}-${synolva}.tar.xz
    fi
  fi
  if [ -e linux-${synolxa}-${synolva}.tar.xz -a ! -e linux-${synolxa}-${synolva}-unpatched ]; then
    tar xJf linux-${synolxa}-${synolva}.tar.xz
    mv linux-${synolxa} linux-${synolxa}-${synolva}-unpatched

    cd $d
    if [ -L arch/arm/plat-armada ]; then
      rm arch/arm/plat-armada
    fi
    if [ -e arch/arm/plat-armada -a ! -e arch/arm/plat-armada-v2 ]; then
      mv arch/arm/plat-armada arch/arm/plat-armada-v2
    fi
    cd ..
  fi

  #p=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}.patch
  #q=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}-extra.patch
  p=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}.patch
  w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB.patch
  q=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-extra.patch
  z=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-extra-bin

  if [ ! -e ${synolra}/${e} ]; then
    echo "Skipping ${p}"
    if [ ${synolva} != 3203 -a ${synolva} != 5644 ]; then
      synolvb=${synolva}
    fi
    continue
  fi

  changerevs=false
  if [ ${synolvb} = mainline -o ${synolvb} = 1373 ]; then
    changerevs=true
  fi
  restoredefs=false
  if [ ${synolva} = 5004 -o ${synolva} = 25426 ]; then
    restoredefs=true
  fi
  removedefs=false
  if [ ${synolva} = 5510 -o ${synolva} = 8451 -o ${synolva} = 22259 ]; then
    if [ ${synolvb} != mainline ]; then
      removedefs=true
    fi
  fi
  removecomm=false
  if [ ${synolva} = 8451 ]; then
    #echo "removecomm=true"
    removecomm=true
  fi

  if [ -L ${synolra}/${e}/arch/microblaze/boot/dts/system.dts -a \
     ! -e ${d}/arch/microblaze/boot/dts/system.dts ]; then
    rm ${synolra}/${e}/arch/microblaze/boot/dts/system.dts
  fi
  
  for f in arch/arm/boot/dts/include/dt-bindings include/uapi/scsi/scsi_ioctl.h \
           synoconfigs/alpine synoconfigs/alpine4k synoconfigs/armada38x synoconfigs/hi3536 synoconfigs/hi3536nvr synoconfigs/monaco ; do
    if [ -L ${synolra}/${e}/$f ]; then
      rm ${synolra}/${e}/$f
    fi
    if [ -L ${d}/$f ]; then
      rm ${d}/$f
    fi
  done

  if [ -e linux-${synolxa}-${synolva}-unpatched -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    #echo "${synolra}/${e} to ${d}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  if [ -e linux-${synolxa}-${synolva}-unpatched -a ${synofam} != ${synofab} -a ! -e ${w} ]; then
    if [ $removedefs = true ]; then
    echo "Creating ${w}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -wbBur a b > ${w} || true
    rm a
    rm b
    fi
  fi

  c=linux-${synolxb}-${synolvb}-patched0
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-remove-defines.patch
  if [ -e ${w} ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/

      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _defabc-${synolvb}-files.txt
      echo "Modifying defines..."
      sh mod-defs.sh ${c} _defabc-${synolvb}
      sh add-abc-defs.sh ${c} ${w}
    fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${synolra}/${e} a
      ln -s ${c} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    synolra=.
    e=${c}
  fi

  c=linux-${synolxb}-${synolvb}-patched0r
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-remove-comments.patch
  if [ -e ${w} -a ${removecomm} = true ]; then
    #echo "removecomm=true part2"
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/

      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _comment-files.txt
      echo "Removing comments..."
      sh remove-comments.sh ${c} -i
    fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${synolra}/${e} a
      ln -s ${c} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    synolra=.
    e=${c}
  fi

  w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2.patch
  x=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2-r.patch
  #echo "diff -wbBur ${synolra}/${e} ${d} > ${w}"
  if [ -e linux-${synolxa}-${synolva}-unpatched -a ${synofam} != ${synofab} -a ! -e ${w} ]; then
    if [ $restoredefs = true -o $removedefs = true ]; then
    echo "Creating ${w}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -wbBur a b > ${w} || true
    #echo "Creating ${x}"
    #diff -wbBur b a > ${x} || true
    rm a
    rm b
    fi
  fi

  if [ -e ${p} ]; then
    rm -f ${z}-files.txt
    rm -f ${z}-files-add.txt
    rm -f ${z}-files-del.txt
    grep '^Nur in ' ${p} | grep -v gitignore | sed "s|: |/|g" | cut -d / -f 2- | sed s/'\.$'/''/g | grep -E '\.pdf$' | while read f ; do
      echo "Binary $f"
      echo ${f}>>${z}-files.txt
      if [ -e ${d}/$f ]; then
        echo ${f}>>${z}-files-add.txt
      else
        echo ${f}>>${z}-files-del.txt
      fi
    done
    if [ -e ${z}-files-add.txt ]; then
      #rm -f ${q}
      cd ${d}
      tar --files-from=../${z}-files-add.txt -czvf ../${z}.tar.gz
      cd ..
    fi
  fi

  if [ -e ${p} -a ! -e ${q} ]; then
    #if grep -q '^Nur in b/' ${p} ; then
    if grep -q '^Nur in ' ${p} ; then
      echo "Creating ${q}"
      #echo "${synolra}/${e} to ${d}"
      ln -s ${synolra}/${e} a
      ln -s ${d} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      #grep '^Nur in b/' ${p} | grep -v gitignore | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
      grep '^Nur in ' ${p} | grep -v gitignore | sed "s|: |/|g" | cut -d / -f 2- | sed s/'\.$'/''/g | while read f ; do
        if echo $f | grep -q -E '\.pdf$' ; then
          continue
        fi
        if [ -d b/$f -o -d b/$f ]; then
          #echo "diff -urN a/$f b/$f"
          diff -urN a/$f b/$f >> ${q} || true
        else
          #echo "diff -uN a/$f b/$f"
          diff -uN a/$f b/$f >> ${q} || true
        fi
      done
      rm a
      rm b
    fi
  fi

  c=linux-${synolxa}-${synolva}-patched0n
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-restore-defines.patch
  if [ -e ${w} -a $restoredefs = true ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${d}/. ${c}/

      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _defabc-${synolvb}-files.txt
      echo "Modifying defines..."
      sh mod-defs.sh ${c} _defabc-${synolvb}
      sh add-abc-defs.sh ${c} ${w} -r
    fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${c} a
      ln -s ${d} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    synolra=.
    d=${c}
  fi

  if [ $changerevs = true ]; then
    w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v0.patch
    
    #echo "Cleanup..."
    #rm -rf linux-${synolxb}-${synolvb}-patched0q/
    #rm -rf linux-${synolxa}-${synolva}-patched0r/

    grep -E '^\+\+\+' ${p} | cut -f 1 | cut -d / -f 2- > _comment-files.txt

    if [ ! -e linux-${synolxb}-${synolvb}-patched0q ]; then
      echo "Creating linux-${synolxb}-${synolvb}-patched0q..."
      mkdir linux-${synolxb}-${synolvb}-patched0q
      cp -apP  linux-${synolxb}-${synolvb}-unpatched/. linux-${synolxb}-${synolvb}-patched0q/

      echo "Removing comments..."
      sh remove-comments.sh linux-${synolxb}-${synolvb}-patched0q -i -m
    fi
    
    if [ ! -e linux-${synolxa}-${synolva}-patched0r ]; then
      echo "Creating linux-${synolxa}-${synolva}-patched0r..."
      mkdir linux-${synolxa}-${synolva}-patched0r
      cp -apP  linux-${synolxa}-${synolva}-unpatched/. linux-${synolxa}-${synolva}-patched0r/

      echo "Removing comments..."
      sh remove-comments.sh linux-${synolxa}-${synolva}-patched0r -i -m
    fi
    
    l="arch/cris/arch-v10/README.mm
    Documentation/video4linux/README.pvrusb2"
    for f in ${l} ; do 
      if [ -e linux-${synolxb}-${synolvb}-patched0q/${f} -a \
           -e linux-${synolxa}-${synolva}-patched0r/${f} ]; then
        cp -p linux-${synolxb}-${synolvb}-patched0q/${f} linux-${synolxa}-${synolva}-patched0r/${f}
      fi
    done
    
    if [ ! -e ${w} ]; then
      echo "Creating ${w}..."
      diff -wbBur linux-${synolxb}-${synolvb}-patched0q linux-${synolxa}-${synolva}-patched0r > ${w} || true
      #grep -E '1\.1\.1\.1' ${w}
    fi
 
    if false ; then
    c=linux-${synolxb}-${synolvb}-patched0m
    r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-change-revisions.patch
    if [ -e ${w} ]; then
      echo "Creating ${c}"
      if [ ! -e ${c} ]; then
        mkdir ${c}
        cp -apP ${synolra}/${e}/. ${c}/
  
        echo "Copying changed files..."
        grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- | while read f ; do
          cp -p ${d}/$f ${c}/$f
        done
      fi
  
      if [ -e ${c} -a ! -e ${r} ]; then
        echo "Creating ${r}"
        #ln -s ${synolra}/${e} a
        #ln -s ${c} b
        ln -s ${c} a
        ln -s ${d} b
        rm -f a/include/linux/version.h
        rm -f b/include/linux/version.h
        diff -ur a b > ${r} || true
        rm a
        rm b
      fi
  
      #synolra=.
      #e=${c}
      #d=${c}
    fi
    fi
  fi

  c=linux-${synolxa}-${synolva}-patched1
  if [ -e ${w} ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/
    fi
    echo "Copying changed files..."
    grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- | while read f ; do
      #echo $f
      cp -p ${d}/$f ${c}/$f
    done
    #grep '^Nur in ' ${w} | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
    #  echo "rm $f"
    #done
  fi

  o=${p}
  p=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v2.patch
  #echo "diff -ur ${synolra}/${e} ${c} > ${p}"
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    ln -s ${synolra}/${e} a
    ln -s ${c} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-whitespace.patch
  if [ $changerevs = true ]; then
    s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-change-revisions.patch
  fi
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${s} ]; then
    echo "Creating ${s}"
    ln -s ${c} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${s} || true
    rm a
    rm b
  fi

  if [ -e ${w} -a ${removecomm} = true -a ! -e linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v3.patch ]; then
    #echo "removecomm=true part3"
    echo "Creating linux-${synolxa}-${synolvb}-patched1w"
    mkdir linux-${synolxa}-${synolvb}-patched1w
    cp -apP linux-${synolxa}-${synolvb}-patched0r/. linux-${synolxa}-${synolvb}-patched1w/

    cd linux-${synolxa}-${synolvb}-patched1w
    echo "Apply linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2.patch"
    patch -p1 < ../linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2.patch || true
    #ls -l include/uapi/scsi/scsi_ioctl.h
    echo "Apply linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v2.patch"
    patch -p1 --force --forward --fuzz=0 < ../linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v2.patch || true
    sh ../rm-orig-and-rej.sh
    cd ..

    ln -s linux-${synolxa}-${synolvb}-patched1w a
    ln -s linux-${synolxa}-${synolva}-patched1 b
    diff -wbBur a b > linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2-fix.patch || true
    rm a
    rm b

    cd linux-${synolxa}-${synolvb}-patched1w
    echo "Apply linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2-fix.patch"
    patch --no-backup-if-mismatch -p1 < ../linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2-fix.patch
    cd ..

    ln -s linux-${synolxa}-${synolvb}-patched1w a
    ln -s linux-${synolxa}-${synolva}-patched1 b
    diff -ur a b > linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2-whitespace.patch || true
    rm a
    rm b

    echo "Creating linux-${synolxa}-${synolvb}-patched2"
    mkdir linux-${synolxa}-${synolvb}-patched2
    cp -apP linux-${synolxa}-${synolvb}-patched0r/. linux-${synolxa}-${synolvb}-patched2/

    cd linux-${synolxa}-${synolvb}-patched2
    patch --no-backup-if-mismatch -p1 < ../linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2.patch || true
    cd ..

    ln -s linux-${synolxa}-${synolvb}-patched2 a
    ln -s linux-${synolxa}-${synolvb}-patched1w b
    diff -ur a b > linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v2-whitespace.patch || true
    rm a
    rm b

    cd linux-${synolxa}-${synolvb}-patched2
    patch --no-backup-if-mismatch -p1 < ../linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2-whitespace.patch || true
    cd ..

    ln -s linux-${synolxa}-${synolvb}-patched0r a
    ln -s linux-${synolxa}-${synolvb}-patched2 b
    diff -ur a b > linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v3.patch || true
    rm a
    rm b

    ln -s linux-${synolxa}-${synolvb}-patched2 a
    ln -s linux-${synolxa}-${synolva}-patched1 b
    diff -ur a b > linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v3-whitespace.patch || true
    #diff -wbBur a b
    rm a
    rm b
  fi

  synolxb=${synolxa}
  synolvb=${synolva}
done

echo OK
