#!/bin/sh
#synolra=../linux-dsx14j-3.2.40-22259
#synofab=88f6180
#synolra=../linux-ds216j-3.10.105-22259
synolra=../linux-ds1511plus-3.10.105-22259
synofaa=x64
synofab=braswell
synolvb=mainline

for b in `cat branch-list.txt` ; do
  
  synolra=../linux-dsx14j-3.2.40-22259
  synofam=comcerto2k
  synolxa=3.2.40
  synolva=${b}

  if [ ${synolva} -gt 15152 ]; then
    synolxa=3.10.105
  elif [ ${synolva} -gt 8451 ]; then
    synolxa=3.10.102
  elif [ ${synolva} -gt 5644 ]; then
    synolxa=3.10.77
  elif [ ${synolva} -gt 5004 ]; then
    synolxa=3.10.35
  fi

  if [ ${synolva} -lt 2636 ]; then
    synolxa=2.6.32
  elif [ ${synolva} -lt 3200 ]; then
    synolxa=3.2.11
  elif [ ${synolva} -lt 3700 ]; then
    synolxa=3.2.30
  fi

  if [ ${synofab} = qoriq -o ${synofab} = 853x -o ${synofab} = 854x -o ${synofab} = 88f6180 ]; then
    synolxa=2.6.32
  fi

  if [ ${synolva} -lt 2636 ]; then
    synolra=../linux-ds211-2.6.32-22259
    synofam=88f628x
  elif [ ${synolva} -lt 3203 ]; then
    synofam=x64
  elif [ ${synolva} -lt 4450 ]; then
    synofam=armada370
  fi

  if [ ${synolxa} = 2.6.32 ]; then
    synolra=../linux-ds211-2.6.32-22259
    synofam=88f628x 
  fi

  if [ ${synolxa:0:5} = 3.10. ]; then
    synolra=../linux-ds216j-3.10.105-22259
    synofam=armada38x
  fi
  if [ ${synolxa:0:5} = 3.10. -a ${synofaa} = x64 ]; then
    synolra=../linux-ds1511plus-3.10.105-22259
    synofam=x64
  fi
  if [ ${synolxa:0:5} = 3.10. -a ${synolva} -lt 5644 ]; then
    synofam=x64
  fi

  if [ ${synolxa:0:5} != "3.10." ]; then
    echo "Skipping ${synofab}/${synolva}/linux-${synolxa}"
    continue
  fi

  echo ""
  v=${synolxa}
  u=https://seafile.servator.de/nas/synology/unmodified/${synofab}/${synolva}/linux-${synolxa}.tar.xz
  d=linux-${synolxa}-${synolva}-unpatched
  e=${d}

  echo $u
  if [ ! -e linux-${synolxa}-${synolva}.tar.xz ]; then
    if wget -N $u ; then
      mv linux-${synolxa}.tar.xz linux-${synolxa}-${synolva}.tar.xz
    fi
  fi
  if [ -e linux-${synolxa}-${synolva}.tar.xz -a ! -e linux-${synolxa}-${synolva}-unpatched ]; then
    echo "Unpacking..."
    tar xJf linux-${synolxa}-${synolva}.tar.xz
    mv linux-${synolxa} linux-${synolxa}-${synolva}-unpatched
  fi

  p=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}.patch
  w=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}-wbB.patch
  q=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}-extra.patch

  changerevs=false
  restoredefs=false
  if [ ${synolva} = 5004 -o ${synolva} = 25426 ]; then
    restoredefs=true
  fi
  removedefs=false

  #if [ -L ${synolra}/${e}/arch/microblaze/boot/dts/system.dts -a \
  #   ! -e ${d}/arch/microblaze/boot/dts/system.dts ]; then
  #  rm ${synolra}/${e}/arch/microblaze/boot/dts/system.dts
  #fi
  
  for f in arch/arm/boot/dts/include/dt-bindings arch/microblaze/boot/dts/system.dts include/uapi/scsi/scsi_ioctl.h \
           synoconfigs/alpine synoconfigs/alpine4k synoconfigs/armada38x synoconfigs/hi3536 synoconfigs/hi3536nvr synoconfigs/monaco ; do
    if [ -L ${synolra}/${e}/$f ]; then
      rm ${synolra}/${e}/$f
    fi
    if [ -L ${d}/$f ]; then
      rm ${d}/$f
    fi
  done

  if [ -e linux-${synolxa}-${synolva}-unpatched -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2.patch
  if [ -e linux-${synolxa}-${synolva}-unpatched -a ${synofam} != ${synofab} -a ! -e ${w} ]; then
    if [ $restoredefs = true -o $removedefs = true ]; then
    echo "Creating ${w}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -wbBur a b > ${w} || true
    rm a
    rm b
    fi
  fi

  if [ -e ${p} -a ! -e ${q} ]; then
    if grep -q '^Nur in b/' ${p} ; then
      echo "Creating ${q}"
      ln -s ${synolra}/${e} a
      ln -s ${d} b
      grep '^Nur in b/' ${p} | grep -v gitignore | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
        diff -uN a/$f b/$f >> ${q} || true
      done
      rm a
      rm b
    fi
  fi

  c=linux-${synolxa}-${synolva}-patched0n
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-restore-defines.patch
  if [ -e ${w} -a $restoredefs = true ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${d}/. ${c}/
    fi
      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _defabc-${synolvb}-files.txt
      echo "Modifying defines..."
      sh mod-defs.sh ${c} _defabc-${synolvb}
      sh add-abc-defs.sh ${c} ${w} -r
    #fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${c} a
      ln -s ${d} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    #synolra=.
    d=${c}
  fi

  c=linux-${synolxa}-${synolva}-patched1
  if [ -e ${w} ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/
    fi
    echo "Copying changed files..."
    grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- | while read f ; do
      #echo $f
      cp -p ${d}/$f ${c}/$f
    done
    #grep '^Nur in ' ${w} | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
    #  echo "rm $f"
    #done
  fi

  o=${p}
  p=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v2.patch
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    ln -s ${synolra}/${e} a
    ln -s ${c} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-whitespace.patch
  if [ $changerevs = true ]; then
    s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-change-revisions.patch
  fi
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${s} ]; then
    echo "Creating ${s}"
    ln -s ${c} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${s} || true
    rm a
    rm b
  fi

  synolvb=${synolva}
done

echo OK
