synolxa=linux-3.2.40-4458-patched1
synolvb=15100

if [ "X$1" != "X" ]; then
  synolxa=$1
fi

synolxr=${synolxa}r

echo "Using ${synolxa}"

file=none
force=false
more=false

do_remove_comments() {
  mkdir -p `dirname $2`

  #if false; then
  #  sed 's/a/aA/g;s/__/aB/g;s/#/aC/g' "$file" |
  #        gcc -P -E $arg - |
  #        sed 's/aC/#/g;s/aB/__/g;s/aA/a/g' > $2
  #

  docp=false
  if [ ${synolvb} -lt 15000 ]; then
    docp=true
  elif echo $file | grep -E '^arch/arm/boot/.*\.S|^arch/arm/include/.*\.S|^arch/arm/kernel/.*\.S|^arch/arm/lib/.*\.S|^arch/arm/mm/.*\.S|'\
'^drivers/net/ethernet/intel/|^fs/fuse/|^Makefile|^scripts/kconfig/|^security/apparmor/' > /dev/null ; then
    docp=true
  elif echo $file | grep -E '^arch/arm/mach-armada375/headsmp.S|^arch/arm/mach-armada38x/headsmp.S|^arch/x86/ia32/ia32entry.S|^arch/x86/kernel/syscall_table_32.S' > /dev/null ; then
    docp=true
  fi

  noforce=false
  if echo $file | grep -E '^arch/powerpc/kernel/head_fsl_booke.S|'\
'^arch/powerpc/kernel/l2cr_85xx.S|'\
'^arch/powerpc/kernel/swsusp_booke.S|'\
'^arch/powerpc/platforms/85xx/bootpage.S|'\
'^arch/powerpc/platforms/85xx/suspend-asm.S' > /dev/null ; then
    docp=true
    noforce=true
  elif [ $force != true ] ; then
    noforce=true
  fi

  nflist1="arch/arm/kernel/calls.S 
arch/ia64/kernel/perfmon.c
drivers/net/tun.c
fs/9p/vfs_dentry.c
fs/btrfs/ctree.c
fs/btrfs/uuid-tree.c
fs/configfs/configfs_internal.h
fs/configfs/dir.c
fs/configfs/file.c
fs/configfs/inode.c 
fs/configfs/item.c
fs/configfs/mount.c
fs/efivarfs/super.c
fs/exec.c
fs/ext4/balloc.c
fs/ext4/extents.c
fs/hostfs/hostfs_kern.c
fs/libfs.c
fs/proc/generic.c
fs/proc/namespaces.c 
include/linux/configfs.h
include/uapi/linux/vhost.h
net/sunrpc/rpc_pipe.c"

  nflist2="fs/btrfs/ordered-data.h
kernel/cgroup.c"

# 3.10
  nflist3="arch/arm/boot/compressed/head.S
arch/arm/common/mcpm_head.S
arch/arm/common/vlock.S
arch/arm/kernel/entry-armv.S
arch/arm/kernel/entry-common.S
arch/arm/kernel/entry-header.S
arch/arm/kernel/head.S
arch/arm/kernel/sleep.S
arch/arm/kvm/init.S
arch/arm/kvm/interrupts.S
arch/arm/lib/copy_page.S
arch/arm/lib/getuser.S
arch/arm/lib/uaccess.S
arch/arm/mach-mvebu/coherency_ll.S
arch/arm/mach-mvebu/headsmp-375.S
arch/arm/mach-mvebu/headsmp-380.S
arch/arm/mach-mvebu/headsmp.S
arch/arm/mach-mvebu/pmsu_ll.S
arch/arm/mach-sti/headsmp.S
arch/arm/mm/abort-ev6.S
arch/arm/mm/cache-v7.S
arch/arm/mm/proc-v6.S
arch/arm/mm/proc-v7-2level.S
arch/arm/mm/proc-v7-3level.S
arch/arm/mm/proc-v7.S
arch/arm/mm/tlb-v7.S
block/partition-generic.c
drivers/md/dm-linear.c
drivers/usb/gadget/configfs.c
net/netfilter/nf_conntrack_core.c
net/netfilter/nf_conntrack_netlink.c
net/netfilter/nf_nat_core.c"

  for n in $nflist1 $nflist3 ; do
    if echo $file | grep -q -E '^'$n  ; then
      docp=true
      noforce=true
    fi
  done

  if [ $docp = true -a $noforce = true ] ; then
    if [ ${synolxa} != ${synolxr} ]; then
      cp -p "$1/$file" $2
    fi
  else
    if [ ${synolxa} = ${synolxr} ]; then
      file=${file}-org
      cp -p $2 "$1/$file"
    fi
#    sed -r ':a; s%(.*)/\*.*\*/%\1%; ta; /\/\*/ !b; N; ba' "$1/$file" | x
    cat "$1/$file" | \
    sed 's|with //|with /_XCFG_/|g' | \
    sed 's|s//|s/_XCFG_/|g' | \
    sed 's|://|:/_XCFG_/|g' | \
    sed 's|=//|=/_XCFG_/|g' | \
    sed 's|"//|"/_XCFG_/|g' | \
sed 's|\*/\\n"|\*_XCFG_/\\n"|g' | \
sed 's|"/\*|"/_XCFG_*|g' | \
sed 's|\*/"|*_XCFG_/"|g' | \
sed 's|"#endif /\*|"#endif /_XCFG_*|g' | \
sed 's|\$Id: //|$Id: /_XCFG_/|g' | \
sed -r ':a; s%(.*)/\*.*\*/%\1%; ta; /\/\*/ !b; N; ba' | \
    sed 's|//.*||g' | \
sed 's|\$Id: /_XCFG_/|$Id: //|g' | \
sed 's|\*_XCFG_/\\n"|\*/\\n"|g' | \
sed 's|"/_XCFG_\*|"/*|g' | \
sed 's|\*_XCFG_/"|\*/"|g' | \
sed 's|"#endif /_XCFG_\*|"#endif /*|g' | \
    sed 's|with /_XCFG_/|with //|g' | \
    sed 's|s/_XCFG_/|s//|g' | \
    sed 's|:/_XCFG_/|://|g' | \
    sed 's|=/_XCFG_/|=//|g' | \
    sed 's|"/_XCFG_/|"//|g' > $2

    if [ $more = true ]; then
      #sed -i s/'^# $Id: .* \$$'/''/g $2
      if echo $file | grep -q -E '^drivers/scsi/aic7xxx' ; then
        sed -i s/'^$Id: .* \$$'/'$Id$'/g $2
        sed -i s/'"$Id: .* \$"'/'"$Id$"'/g $2
      fi
      sed -i 's|# \$Id: .*,v .* .......... ..:..:.. .* \$|# $Id$|g' $2

      sed -i s/'#define DRIVER_VERSION "\$Revision: .* \$"'/'#define DRIVER_VERSION "$Revision: 1.1.1.1 $"'/g $2
      sed -i s/'revision = "\$Revision: .* \$";'/'revision = "$Revision: 1.1.1.1 $";'/g $2
      sed -i 's|^\$Id: .* \$$|$Id: file,v 1.1.1.1 2000/01/01 12:00:00 khchen Exp $|g' $2
      sed -i s/'^#define.DRIVER_VERSION."$Revision: .* \$"'/'#define DRIVER_VERSION "$Revision: 1.1.1.1 $"'/g $2
      sed -i s/'^#define VERSION."\$Revision: .* \$"'/'#define VERSION "$Revision: 1.1.1.1 $"'/g $2
      sed -i s/'version = "\$Revision: .* \$";'/'version = "$Revision: 1.1.1.1 $";'/g $2
      sed -i 's|VERSION = "\$Id: .*,v .* .......... ..:..:.. .* \$"|VERSION = "$Id: file,v 1.1.1.1 2000/01/01 12:00:00 khchen Exp $"|g' $2
      sed -i 's|\$Id: .*,v .* .......... ..:..:.. .* \$|$Id: file,v 1.1.1.1 2000/01/01 12:00:00 khchen Exp $|g' $2
      sed -i 's|\$Header: .*,v .* ..../../.. ..:..:.. .* \$|$Header: file,v 1.1.1.1 2000/01/01 12:00:00 khchen Exp $|g' $2
      sed -i 's|\$Header: .*,v .* ....-..-.. ..:..:.. .* \$|$Header: file,v 1.1.1.1 2000/01/01 12:00:00 khchen Exp $|g' $2
      sed -i 's|\$Date: ..../../.. ..:..:.. \$|$Date: 2000/01/01 12:00:00 $|g' $2
      sed -i 's|\$Date: ....-..-.. ..:..:.. \$|$Date: 2000/01/01 12:00:00 $|g' $2
      sed -i s/'\$Revision: .* \$'/'\$Revision: 1.1.1.1 \$'/g $2
      sed -i 's|Revision .*  ..../../.. ..:..:..  |Revision 1.1  2000/01/01 12:00:00  |g' $2
      sed -i 's|Revision .*  ....-..-.. ..:..:..  |Revision 1.1  2000/01/01 12:00:00  |g' $2
    fi

    if [ ${synolxa} = ${synolxr} ]; then
      rm -f "$1/$file"
    fi
  fi
}

if [ "X$2" = "X-i" ]; then
  synolxr=${synolxa}
else
  mkdir ${synolxr}
  cp -apP ${synolxa}/. ${synolxr}/
fi

if [ "X$3" = "X-m" ] ; then
  more=true
fi

if [ "X$2" = "X-f" ] ; then
for f in `cat _defabc-files.txt` ; do
  file=$f
  if [ -e ${synolxr}/$file ]; then
    echo $f
    do_remove_comments ${synolxa} ${synolxr}/$file
  else
    echo "not found $f"
  fi
done
fi

force=true

for f in `cat _comment-files.txt` ; do
  file=$f
  if [ -e ${synolxr}/$file ]; then
    echo $f
    do_remove_comments ${synolxa} ${synolxr}/$file
  else
    echo "not found $f"
  fi
done
#fi
